Xapian: API Documentation: xapian-core: Xapian::Weight Class Reference

# Xapian::Weight Class Reference

Abstract base class for weighting schemes. More...

Inheritance diagram for Xapian::Weight:

[legend]

List of all members.

## Public Member Functions
virtual | ~Weight ()
| Virtual destructor, because we have virtual methods.
virtual Weight * | clone () const =0
| Clone this object.
virtual std::string | name () const
| Return the name of this weighting scheme.
virtual std::string | serialise () const
| Return this object's parameters serialised as a single string.
virtual Weight * | unserialise (const std::string &s) const
| Unserialise parameters.
virtual Xapian::weight | get_sumpart (Xapian::termcount wdf, Xapian::termcount doclen) const =0
| Calculate the weight contribution for this object's term to a document.
virtual Xapian::weight | get_maxpart () const =0
| Return an upper bound on what get_sumpart() can return for any document.
virtual Xapian::weight | get_sumextra (Xapian::termcount doclen) const =0
| Calculate the term-independent weight component for a document.
virtual Xapian::weight | get_maxextra () const =0
| Return an upper bound on what get_sumextra() can return for any document.
## Protected Types
enum | stat_flags
| Stats which the weighting scheme can use (see need_stat()).
## Protected Member Functions
void | need_stat (stat_flags flag)
| Tell Xapian that your subclass will want a particular statistic.
virtual void | init (double factor)=0
| Allow the subclass to perform any initialisation it needs to.
| Weight (const Weight &)
| Don't allow copying.
| Weight ()
| Default constructor, needed by subclass constructors.
Xapian::doccount | get_collection_size () const
| The number of documents in the collection.
Xapian::doccount | get_rset_size () const
| The number of documents marked as relevant.
Xapian::doclength | get_average_length () const
| The average length of a document in the collection.
Xapian::doccount | get_termfreq () const
| The number of documents which this term indexes.
Xapian::doccount | get_reltermfreq () const
| The number of relevant documents which this term indexes.
Xapian::termcount | get_query_length () const
| The length of the query.
Xapian::termcount | get_wqf () const
| The within-query-frequency of this term.
Xapian::termcount | get_doclength_upper_bound () const
| An lower bound on the maximum length of any document in the database.
Xapian::termcount | get_doclength_lower_bound () const
| An upper bound on the maximum length of any document in the database.
Xapian::termcount | get_wdf_upper_bound () const
| An upper bound on the wdf of this term.

## Detailed Description

Abstract base class for weighting schemes.

## Constructor & Destructor Documentation

virtual Xapian::Weight::~Weight | ( |  | ) | `[virtual]`

Virtual destructor, because we have virtual methods.

Xapian::Weight::Weight | ( | const Weight & |  | ) | `[protected]`

Don't allow copying.

This would ideally be private, but that causes a compilation error with GCC 4.1 (which appears to be a bug).

## Member Function Documentation

virtual Weight* Xapian::Weight::clone | ( |  | ) | const`[pure virtual]`

Clone this object.

This method allocates and returns a copy of the object it is called on.

If your subclass is called FooWeight and has parameters a and b, then you would implement FooWeight::clone() like so:

FooWeight * FooWeight::clone() const { return new FooWeight(a, b); }

Note that the returned object will be deallocated by Xapian after use with "delete". It must therefore have been allocated with "new".

Xapian::termcount Xapian::Weight::get_doclength_lower_bound | ( |  | ) | const`[inline, protected]`

An upper bound on the maximum length of any document in the database.

This should only be used by get_maxpart() and get_maxextra().

Xapian::termcount Xapian::Weight::get_doclength_upper_bound | ( |  | ) | const`[inline, protected]`

An lower bound on the maximum length of any document in the database.

This should only be used by get_maxpart() and get_maxextra().

virtual Xapian::weight Xapian::Weight::get_maxextra | ( |  | ) | const`[pure virtual]`

Return an upper bound on what get_sumextra() can return for any document.

This information is used by the matcher to perform various optimisations, so strive to make the bound as tight as possible.

Implemented in Xapian::BoolWeight, Xapian::BM25Weight, and Xapian::TradWeight.

virtual Xapian::weight Xapian::Weight::get_maxpart | ( |  | ) | const`[pure virtual]`

Return an upper bound on what get_sumpart() can return for any document.

This information is used by the matcher to perform various optimisations, so strive to make the bound as tight as possible.

Implemented in Xapian::BoolWeight, Xapian::BM25Weight, and Xapian::TradWeight.

virtual Xapian::weight Xapian::Weight::get_sumextra | ( | Xapian::termcount | doclen | ) | const`[pure virtual]`

Calculate the term-independent weight component for a document.

The parameter gives information about the document which may be used in the calculations:

Parameters:

  | doclen | The document's length (unnormalised).

Implemented in Xapian::BoolWeight, Xapian::BM25Weight, and Xapian::TradWeight.

virtual Xapian::weight Xapian::Weight::get_sumpart | ( | Xapian::termcount | wdf,
|  | Xapian::termcount | doclen |
| ) |  |  | const`[pure virtual]`

Calculate the weight contribution for this object's term to a document.

The parameters give information about the document which may be used in the calculations:

Parameters:

  | wdf | The within document frequency of the term in the document.
  | doclen | The document's length (unnormalised).

Implemented in Xapian::BoolWeight, Xapian::BM25Weight, and Xapian::TradWeight.

Xapian::termcount Xapian::Weight::get_wdf_upper_bound | ( |  | ) | const`[inline, protected]`

An upper bound on the wdf of this term.

This should only be used by get_maxpart() and get_maxextra().

virtual void Xapian::Weight::init | ( | double | factor | ) | `[protected, pure virtual]`

Allow the subclass to perform any initialisation it needs to.

Parameters:

  | factor | Any scaling factor (e.g. from OP_SCALE_WEIGHT).

virtual std::string Xapian::Weight::name | ( |  | ) | const`[virtual]`

Return the name of this weighting scheme.

This name is used by the remote backend. It is passed along with the serialised parameters to the remote server so that it knows which class to create.

Return the full namespace-qualified name of your class here - if your class is called FooWeight, return "FooWeight" from this method (Xapian::BM25Weight returns "Xapian::BM25Weight" here).

If you don't want to support the remote backend, you can use the default implementation which simply returns an empty string.

Reimplemented in Xapian::BoolWeight, Xapian::BM25Weight, and Xapian::TradWeight.

void Xapian::Weight::need_stat | ( | stat_flags | flag | ) | `[inline, protected]`

Tell Xapian that your subclass will want a particular statistic.

Some of the statistics can be costly to fetch or calculate, so Xapian needs to know which are actually going to be used. You should call need_stat() from your constructor for each such statistic.

Parameters:

  | flag | The stat_flags value for a required statistic.

virtual std::string Xapian::Weight::serialise | ( |  | ) | const`[virtual]`

Return this object's parameters serialised as a single string.

If you don't want to support the remote backend, you can use the default implementation which simply throws Xapian::UnimplementedError.

Reimplemented in Xapian::BoolWeight, Xapian::BM25Weight, and Xapian::TradWeight.

virtual Weight* Xapian::Weight::unserialise | ( | const std::string & | s | ) | const`[virtual]`

Unserialise parameters.

This method unserialises parameters serialised by the serialise() method and allocates and returns a new object initialised with them.

If you don't want to support the remote backend, you can use the default implementation which simply throws Xapian::UnimplementedError.

Note that the returned object will be deallocated by Xapian after use with "delete". It must therefore have been allocated with "new".

Parameters:

  | s | A string containing the serialised parameters.

Reimplemented in Xapian::BoolWeight, Xapian::BM25Weight, and Xapian::TradWeight.

The documentation for this class was generated from the following file:

- xapian/weight.h